Bug 444106 - unable to select multicast (IPv4) source interface
unable to select multicast (IPv4) source interface
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: ntp (Show other bugs)
5.1
All Linux
medium Severity medium
: rc
: ---
Assigned To: Miroslav Lichvar
Brian Brock
:
Depends On:
Blocks: 391501
  Show dependency treegraph
 
Reported: 2008-04-24 22:13 EDT by Andrew Ryan
Modified: 2010-10-22 20:29 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 16:16:29 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
backported patch to fix selecting multicast interface (1.54 KB, patch)
2008-05-06 11:33 EDT, Miroslav Lichvar
no flags Details | Diff

  None (edit)
Description David Robinson 2008-04-24 22:13:44 EDT
Description of problem:
ntp on RHEL5 (ntp-4.2.2p1-8.el5) selects the wrong interface on which to send
multicast traffic, if there is more than one interface available.  In RHEL5's
ntp, the service seems to always select eth0 no matter what the multicast
interface really is.

Version-Release number of selected component (if applicable):
ntp-4.2.2p1-8.el5
Red Hat Enterprise Linux Server release 5.1 (Tikanga)

How reproducible:
always

Steps to Reproduce:
1) Set up a system to be an ntp multicast server..  

2) On the same system set up another eth interface (anything but eth0) to do
multicast routing, i.e.:

[root@dhcp243-73 ntpd]# netstat -rn
Kernel IP routing table
Destination     Gateway         Genmask         Flags   MSS Window  irtt Iface
192.168.1.0     0.0.0.0         255.255.255.0   U         0 0          0 eth1
192.168.122.0   0.0.0.0         255.255.255.0   U         0 0          0 virbr0
10.11.242.0     0.0.0.0         255.255.254.0   U         0 0          0 eth0
169.254.0.0     0.0.0.0         255.255.0.0     U         0 0          0 eth1
224.0.0.0       0.0.0.0         240.0.0.0       U         0 0          0 eth1


3) Run the following command and observe the output:
ntpd -u ntp:ntp -p /var/run/ntpd.pid -D9  

Actual results:
In the RHEL5 implementation of ntp, ntp selects eth0 for the broadcast interface
instead of eth1 (output from ntpd command above):

getaddrinfo 224.0.1.1
getnetnum given 224.0.1.1, got 224.0.1.1
newpeer: cast flags: 0x2 for address: 224.0.1.1
Finding broadcast interface for addr 224.0.1.1 in list of addresses
Finding addr 224.0.1.1 in list of addresses
Found bcastinter index -1
Found broadcast interface address 10.11.243.73, for address 224.0.1.1
Added IPv4 multicast interface on socket 24, addr 10.11.243.73 for
multicast address 224.0.1.1
newpeer: using fd 24 and our addr 10.11.243.73

Expected results:
ntp should properly detect the multicast interface.

Additional info:
This was fixed upstream in ntp 4.2.4, the bug report is here:

https://support.ntp.org/bugs/show_bug.cgi?id=785

I've looked into backporting this fix to ntp-4.2.2p1 but it doesn't look good.
The file that the patch applies to is 22 Kb larger in 4.2.4 than in 4.2.2p1, and
the functions the patch touches don't even exist in 4.2.2. The whole strategy of
dealing with this problem has changed between 4.2.2 and 4.2.4.
Comment 1 Miroslav Lichvar 2008-05-06 11:33:47 EDT
Created attachment 304645 [details]
backported patch to fix selecting multicast interface
Comment 2 Issue Tracker 2008-05-08 13:33:44 EDT
Miroslav,

Can you please post some RHEL5 test packages with this fix in it for
Lawrence Livermore? 

Thanks.


This event sent from IssueTracker by kbaxley 
 issue 172596
Comment 3 Miroslav Lichvar 2008-05-12 05:43:20 EDT
Test packages with the patch included are at:

http://people.redhat.com/mlichvar/tmp/ntpmcast/
Comment 5 RHEL Product and Program Management 2008-06-02 16:04:04 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 12 errata-xmlrpc 2009-01-20 16:16:29 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-0125.html

Note You need to log in before you can comment on or make changes to this bug.